## org.apache.http.impl.io
Class ChunkedInputStream

    java.lang.Object
      java.io.InputStream
          org.apache.http.impl.io.ChunkedInputStream

All Implemented Interfaces:
  Closeable

    @NotThreadSafe
    public class ChunkedInputStream

extends InputStream

Implements chunked transfer coding. The content is received in small chunks. Entities transferred using this input stream can be of unlimited length. After the stream is read to the end, it provides access to the trailers, if any.

Note that this class NEVER closes the underlying stream, even when close gets called. Instead, it will read until the "end" of its chunking on close, which allows for the seamless execution of subsequent HTTP 1.1 requests, while not requiring the client to remember to read the entire contents of the response.

Since:
  4.0

Constructor Summary
`ChunkedInputStream(SessionInputBuffer in)` Wraps session input stream and reads chunk coded input.

Method Summary
`int` `available()`
`void` `close()` Upon close, this reads the remainder of the chunked message, leaving the underlying socket at a position to start reading the next response without scanning.
`Header[]` `getFooters()`
`int` `read()` Returns all the data in a chunked stream in coalesced form.
`int` `read(byte[] b)` Read some bytes from the stream.
`int` `read(byte[] b, int off, int len)` Read some bytes from the stream.

Methods inherited from class java.io.InputStream
`mark, markSupported, reset, skip`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ChunkedInputStream

    public ChunkedInputStream(SessionInputBuffer in)

  Wraps session input stream and reads chunk coded input.

  Parameters:
    `in` - The session input buffer

Method Detail

### available

    public int available()
                  throws IOException

  Overrides:
    `available` in class `InputStream`
  Throws:
    `IOException`

### read

    public int read()
             throws IOException

  Returns all the data in a chunked stream in coalesced form. A chunk is followed by a CRLF. The method returns -1 as soon as a chunksize of 0 is detected.

  Trailer headers are read automatically at the end of the stream and can be obtained with the getResponseFooters() method.

  Specified by:
    `read` in class `InputStream`
  Returns:
    -1 of the end of the stream has been reached or the next data byte
  Throws:
    `IOException` - in case of an I/O error

### read

    public int read(byte[] b,
                    int off,
                    int len)
             throws IOException

  Read some bytes from the stream.

  Overrides:
    `read` in class `InputStream`
  Parameters:
    `b` - The byte array that will hold the contents from the stream.
    `off` - The offset into the byte array at which bytes will start to be placed.
    `len` - the maximum number of bytes that can be returned.
  Returns:
    The number of bytes returned or -1 if the end of stream has been reached.
  Throws:
    `IOException` - in case of an I/O error

### read

    public int read(byte[] b)
             throws IOException

  Read some bytes from the stream.

  Overrides:
    `read` in class `InputStream`
  Parameters:
    `b` - The byte array that will hold the contents from the stream.
  Returns:
    The number of bytes returned or -1 if the end of stream has been reached.
  Throws:
    `IOException` - in case of an I/O error

### close

    public void close()
               throws IOException

  Upon close, this reads the remainder of the chunked message, leaving the underlying socket at a position to start reading the next response without scanning.

  Specified by:
    `close` in interface `Closeable`
  Overrides:
    `close` in class `InputStream`
  Throws:
    `IOException` - in case of an I/O error

### getFooters

    public Header[] getFooters()

Copyright © 2005-2013 The Apache Software Foundation. All Rights Reserved.